class cosa {

  PVector pos, vel, acc;
  float sz, mass;

  cosa() {
    pos = new PVector(random(width), random(height));
    vel = new PVector(0, 0);
    acc = new PVector(0, 0);
    sz = random(4, 20);
    mass = sz;
  }

  void run() {
    update();
    drawMe();
  }

  void update() {
    checkBorders();
    //  acc.limit(1);
    vel.add(acc);
    pos.add(vel);
    acc.mult(0);
  }

  void drawMe() {
    stroke(0);
    fill(255,50);
//    ellipse(pos.x, pos.y, sz, sz);
  }

  void applyForce(PVector _f) {
    PVector f = _f.get(); 
    f.div(mass);
    acc.add(f);
  }

  void checkBorders() {
    //    if(pos.x > width)pos.x=0;
    //    else if (pos.x<0)pos.x=width;
    //        if(pos.y > height)pos.y=0;
    //    else if (pos.y<0)pos.y=height;
    //en lo horizontal, como siempre
    if (pos.x > width) {
      pos.x = width;
      vel.x *=-1;
      vel.mult(0.9);
    } 
    else if (pos.x < 0) {
      pos.x = 0;
      vel.x *=-1;
      vel.mult(0.9);
    }

    if (pos.y > height) {
      pos.y = height;
      vel.y *=-1;
      vel.mult(0.9);
    } 
    else if (pos.y < 0) {
      pos.y = 0;
      vel.y *=-1;
      vel.mult(0.9);
    }
  }

  void mouseAttract() {
    vel.mult(0);
    //stroke(109,130,250);
    //line(pos.x, pos.y, mouseX, mouseY); 

    PVector dis = new PVector(mouseX-pos.x, mouseY-pos.y);
    //println(dis.mag());
    float distanceToMove = dis.mag()*0.5;
    //println(distanceToMove);
    dis.normalize();
    dis.mult(distanceToMove);
    applyForce(dis);
  }
}

